"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _helperPluginUtils = require("@babel/helper-plugin-utils");
var _default = exports.default = (0, _helperPluginUtils.declare)(({
  types: t,
  assertVersion
}) => {
  assertVersion("^7.13.0");
  return {
    name: "proposal-async-do-expressions",
    manipulateOptions: (_, parser) => parser.plugins.push("asyncDoExpressions", "doExpressions"),
    visitor: {
      DoExpression: {
        exit(path) {
          if (!path.node.async) {
            return;
          }
          {
            var _path$scope, _path$scope$hoistVari;
            (_path$scope$hoistVari = (_path$scope = path.scope).hoistVariables) != null ? _path$scope$hoistVari : _path$scope.hoistVariables = require("@babel/traverse").Scope.prototype.hoistVariables;
          }
          path.scope.hoistVariables();
          const bodyPath = path.get("body");
          const completionRecords = bodyPath.getCompletionRecords();
          for (const p of completionRecords) {
            if (p.isExpressionStatement()) {
              p.replaceWith(t.returnStatement(p.node.expression));
            }
          }
          path.replaceWith(t.callExpression(t.arrowFunctionExpression([], bodyPath.node, true), []));
        }
      }
    }
  };
});

//# sourceMappingURL=index.js.map
